/* MkCustom -- the "save client preferences" portion of CUSTOMIZE:
               SRE-http's "client specific preferences" facility
*/


mkcustom:
parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir

if verb=" " then do
   say "This SRE-http procedure is not meant to be run in standalone mode "
   exit
end  /* Do */

list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */

init=0 ; vars.0=0 ;
password=' ' ; nodelete=0 ;
setname="DEFAULT" ;
identifier=0 ;
response=0 ;
expire="" ;
path="/" ;
nvars=0; invars=0
do ll=1 to 100 ; initvars.ll='' ; end;

/* parse out args */
do until list=""
 parse var list a1 '&' list
 parse var a1 avar '=' aval
 aval=packur(aval) ; avar=upper(strip(avar))
 taval=strip(upper(aval))
 select
    when avar="SETNAME" then setname=taval
    when avar="IDENTIFIER" then identifier=taval
    when avar="PASSWORD" then password=taval
    when avar="NODELETE" then nodelete=taval
    when avar="RESPONSE" then response=taval
    when avar="EXPIRE" then expire=taval
    when avar="PATH" then path=taval
    when avar="INIT" then  init=taval
    when abbrev(avar,'VAR.')=1 then do
          parse var avar . '.' vname 
          if vname="" then iterate
          if datatype(vname)='NUM' then do
               if vname<100 then do
                    initvars.vname=strip(upper(aval))
                    if initvars.vname<>' ' & initvars.vname<>0 then invars=invars+1
                    iterate
               end  /* Do */
               if vname>100 then do
                     jj=vname-100
                     initvars.!val.jj=aval
                     iterate
               end  /* Do */
          end  /* initvar special case */
          nvars=nvars+1
          vars.!name.nvars=vname
          vars.!val.nvars=aval
    end
    otherwise nop
 end  /* select */
end /* do */

/* cleanup values */
if identifier=0 | identifier="" then do
     identifier=0
     password="" ; nodelete=1
end  /* Do */
if wordpos(init,'Y 1 YES')>0 then do 
    init=1 ; expire=0
    response=0
    identifier='DEFAULT'
    if wordpos('SUPERUSER',privset) then do
       foo=is_error(' Initialization allowed for SUPERUSERs only ')
       return foo
    end
end  /* Do */
if password<>""  then nodelete=0
if wordpos(nodelete,'Y 1 YES')>0 then nodelete=1
if datatype(expire)<>'NUM' then expire=' '


if invars+nvars=0 then do
    foo=is_error(' No variables specified ')
    return foo
end  /* Do */


/* specify the DIR */
adir=value(enmadd||'USERINFO_DIR',,'os2environment')
if adir="" then
   adir=value(enmadd||'TEMPDATA_DIR',,'os2environment')
adir=strip(adir,'t','\')
if setname<>"DEFAULT" & setname<>0 & SETNAME<>"" then adir=adir||'\'||setname
if dosisdir(adir)<>1 then do
    if init=1 then do
          foo=dosmkdir(adir)
          if verbose>1 then call pmprintf_sref(" Directory created " adir " ; " foo)
          if foo=0 then do
            foo=is_error(' Unable to initialize directory: '||adir)
            return foo
           end  /* Do */
    end  /* Do */
    else do
       foo=is_error(' Unable to create client preferences file for '||setname)
       return foo
    end
end  /* Do */


/* DOES FILE EXIST */
IF IDENTIFIER=0 | IDENTIFIER="" then do
    aIDENTIFIER='C???????.CLI'
end
ELSE do
    aIDENTIFIER=IDENTIFIER||'.CLI'
end
fname=adir||'\'||aIDENTIFIER
if pos('?',fname)>0 then do
   FNAME=DOSTEMPNAME(fname)
   if fname=' ' then do
        foo=is_error( ' Can not create file, even with wildcards. ')
        return foo
   end /* do */
   else

   jj=lastpos('\',fname)
   ide=substr(fname,jj+1)
   parse var ide identifier '.' .
end

isf=stream(fname,'c','query exists')
/* file exists: can we modify it */
if isf<>"" & nodelete=1 & init=0 then do     /* overwrite not allowed */
     foo=is_error(' Can not create/modify preferences file: name is being used (try a different name) ')
     return foo
end  /* Do */
/* note: if init=1, just overwrite default.cli */


drop varset.

/* if init=1, then write the varnames, and return */
if init=1  then do
   do jj=1 to 100
      if initvars.jj=' ' then iterate
      am=upper(initvars.jj)
/* prevent overwrite of reserved words */
      if wordpos(am,'!NODELETE !PASSWORD !CREATION !WHO !IDENTIFIER ')>0 then iterate
      if datatype(am)='NUM' then iterate
      varset.am=initvars.!val.jj
   end /* do */
   varset.!creation=time('N')||' '||date('n')
   varset.!who=user
   varset.!identifier=identifier
   varset.!nodelete=1
   varset.!password=' '
   varset.!expires=' '
   varset.!path=' '
   aa=cvwrite(fname,varset)
   if aa=0 then do
        foo=is_error(' Could not write Default.cli ')
        return foo
   end
   else do
        foo=is_success(' Initialized: ' fname ' with ' invars ' variables',response)
        return 'MKCUSTOM success '
   end
end

/* not init.
 If file does not exist, then add variables and add them; possbly add
  PASSWORD and NODELETE flags.
 If does exist, then perhaps append them -- but first check NODELETE (creation)
 and PASSWORD conditions */


 if isf<>' ' then do    /* file exists; can we modify it? */
       oo=cvread(isf,varset)
       if symbol('varset.!Nodelete')='VAR' then do
         if  varset.!Nodelete=1  then do
             foo=is_error(' Not allowed to modify preferences file ')
             return foo
          end  /* Do */
       end
       if symbol('VARSET.!PASSWORD')='VAR' then do
          if varset.!password<>password then do
              foo=is_error(' Incorrect password, not allowed to modify preferences file ')
              return foo
          end
       end
  end
/* add variables to varset (possibly empty ) */
  do mm=1 to nvars
     av=vars.!name.mm
     varset.av=vars.!Val.mm
  end
 if password<>' ' then varset.!password=password
 varset.!nodelete=nodelete
 varset.!creation=time('N')||' '||date('n')
 varset.!who=user
 varset.!identifier=identifier
 varset.!password=password
 varset.!expire=expire
 if expire<>' ' & expire<>0 then varset.!expire=sref_gmt(expire)
 varset.!path=path
 aa=cvwrite(fname,varset)
 if aa=0 then do
        foo=is_error(' Could not write preferences... ')
        return foo
  end
  else do
        foo=is_success(' Your ' nvars ' preferences have been saved.',response)
        return 'MKCUSTOM success '
  end

return 0

/*******/
is_error:
parse arg amess


  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  call lineout tempfile, "<html><head><title>Client customization error</title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Client customization error</h2>'
  call lineout tempfile, amess
  call lineout tempfile,' </body></html>'
  call lineout tempfile
  return 'FILE ERASE TYPE text/html NAME' tempfile



/*******/
is_success:procedure expose tempfile identifier setname expire path servername
parse arg amess,response
  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  call lineout tempfile, "<html><head><title>Client customization</title>"
  call lineout tempfile, "</head><body>"
  call lineout tempfile,' <h2>Client customization</h2>'
  call lineout tempfile, amess
  fii=value('SREF_PREFIX',,'os2environment')
  if translate(response,' ',0)<>' ' then do
      call lineout tempfile,' <BR> Examine <a href="'||response||'">'||response||'</a> '
      serverport=extract('serverport') 
      xsel=sref_fix_url(response,lower(servername),serverport)
      if fii='' then do
         'RESPONSE HTTP/1.0 302 Moved Temporarily'  
      end
      else do
         'RESPONSE HTTP/1.0 302 Moved Temporarily'  
         foo=sref_gmt()
         'HEADER NOAUTO ADD Date: 'foo
         foo0=strip(server())||'; SRE-http 'sref_version(,1)
         'Header add Server: 'foo0
         'Header add Cache-Control: no-cache'
      end /* do */
/* Set HTTP response line */
      'HEADER ADD Location:' xsel 
  end
  call lineout tempfile,' </body></html>'
  call lineout tempfile
  if exipre<>0 | expire="" then do
     a1=setname'='identifier
     a2=' '; if expire<>' ' then a2=' ; expires='||sref_gmt(expire)
     a3=' ; PATH='path
    'HEADER ADD Set-Cookie: '||a1||a2||a3  
/* 'header add set-cookie: '||a1  */ 

  end
  if fii='' then
     'FILE ERASE TYPE text/html NAME' tempfile
  else
     goo=sref_gos('FILE ERASE TYPE text/html NAME' tempfile)

 return 0



