/* This utility will read/view a .CLI file-- a MKCUSTOM generated
client customization file */
parse arg is1

/*---   Load REXX libraries ----- */
/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'

  call SysLoadFuncs
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end


say ' Enter a .CLI "client customization file" to retrieve '
say ' You can use * as a wild card -- if one file matches it will be used '
say '                                 if multiple matches, a list will be shown '
say " "

doedit=0
if is1="" then do
   call charout, " Do you want to edit entries (Y = yes)? "
   pull adoedit
   if pos(adoedit,'Y YES 1')>0 then doedit=1
end

agin:say " "
if is1="" then do
    call charout," Enter the filename: "
    pull afile
end /* do */
else do
   afile=is1
end /* do */
if pos('.',afile)=0 then afile=afile||'.CLI'

if pos('*',afile)>0 then do
    woo=sysfiletree(afile,eeks,'FO')
   if eeks.0=0 then do
        say " No matches! "
         if is1<>' ' then exit
        signal agin
   end /* do */
   if eeks.0=1 then do 
       say " Matched file= " eeks.1
       afile=eeks.1
   end /* do */
   if eeks.0>1 then do
        iii=min(eeks.0,10)
        say " First " iii " matches: "
        do lp=1 to iii
             say eeks.lp
        end /* do */
        if is1<>' ' then exit
        signal agin
   end
end /* do */
oo=cvread(afile,s1)

if oo=0 then do
    say " no such file : " afile
    exit
end /* do */


oo=cvtails(s1,s2)
say " # of entries= " s2.0
oo=arraysort(s2)
do mm=1 to s2.0
    aa=s2.mm
    bb=s1.aa
    if doedit=1 then do
        call charout,aa" :  "
        cc=stringin(,length(aa)+4,bb,70-length(aa))
        say "" ;   
        s1.aa=cc
    end /* do */
    else do    
       say " Entry: " aa  " = " bb 
       if mm//20=0 then do
          say " (hit enter to continue) " ; parse pull ook
       end /* do */
    end /* do */
end
say ' '
if doedit=1 then do
   call charout,' Hit 0 to NOT save results: '
   parse pull stp ; if stp=0 then exit
   yy=cvwrite(afile,s1)
  if yy<>1 then 
      say " error: could not write " afile
   else
      say " file saved: " afile
end /* do */

exit
